#include <stdio.h>
#include <mysql.h>

#define def_host_name	"localhost"
#define def_user_name	NULL
#define def_password	NULL
#define def_db_name	"test_db"

MYSQL *cnx_init;
MYSQL *cnx_db;

MYSQL_RES *result_set;
MYSQL_ROW row;
unsigned int ctr;

/*Prototypy funkcji*/
void show_result_set (MYSQL_RES *in_result_set);

int main (int argc, char *argv[])
{
        printf("zaczynamy\n");

        cnx_init=mysql_init(NULL);
        if (cnx_init==NULL)
                 {printf("blad w mysql_init\n");
                  printf("Wyjscie z programu 1\n");
                  exit(1);
                  }
        cnx_db = mysql_real_connect (cnx_init,
                            def_host_name,
                            def_user_name,
                            def_password,
                            def_db_name,
                            0,
                            NULL,
                            0);
if (cnx_db == NULL) {
               printf("wystapil blad w mysql_real_connect\n");
               printf("Wyjscie z programu 2\n");
               printf("Blad %u -- %s\n",
                mysql_errno(cnx_init),
                mysql_errno(cnx_init));
               exit(2);
}
printf("Bazy danych\n");
printf("============\n");
if (mysql_query(cnx_init, "SHOW DATABASES")!=0)
         printf("Blad podczas wykonywania show databases\n");
       else
          {
           result_set = mysql_store_result (cnx_init);
            if (result_set == NULL)
                printf("blad w mysql_store_result
                         dla SHOW DATABASES");
                 else
                     {
                       show_result_set (result_set);
                      }
   }
printf("Tabele\n");
printf("============\n");
if (mysql_query(cnx_init, "SHOW TABLES")!=0)
         printf("Blad podczas wykonywania show tables\n");
       else
          {
           result_set = mysql_store_result (cnx_init);
            if (result_set == NULL)
                printf("blad w mysql_store_result
                         dla SHOW TABLES");
                 else
                     {
                       show_result_set (result_set);
                      }
   }
printf("Rekordy\n");
printf("============\n");
if (mysql_query(cnx_init, "select * from tbl_ksiazki_1")!=0)
         printf("Blad podczas wykonywania select\n");
       else
          {
           result_set = mysql_store_result (cnx_init);
            if (result_set == NULL)
                printf("blad w mysql_store_result
                         dla instrukcji Select");
                 else
                     {
                       show_result_set (result_set);
                      }
   }
printf("Wykonanie zapytania\n");
printf("====================\n");
if (mysql_query(cnx_init, "Update tbl_ksiazki_1
                          set rok = 1940
                            where nazwisko='Ayn Rand'")!=0)
         {
                  printf("Blad w mysql_query,
                 instrukcja Update.\n");
                 printf("Wyjscie z programu 4\n");
                 printf("Blad %u -- %s\n",
                      mysql_errno(cnx_init),
                      mysql_error(cnx_init));
                 exit(4);
         }
       else
        { printf ("zapytanie wykonano: %lu rekordow \n",
             (unsigned long) mysql_affected_rows(cnx_init));
}
mysql_close(cnx_init);

printf("zakoczenie dzialania programu\n");
exit(0);
}
void show_result_set (MYSQL_RES *in_result_set)
{
   while ((row = mysql_fetch_row (in_result_set)) != NULL)
       {for (ctr=0;ctr<mysql_num_fields (in_result_set); ctr++)
             { if(ctr>0)
                fputc ('\t',stdout);
}
}
if (mysql_errno (cnx_init) != 0)
{ printf ("blad w mysql_fetch_row\n");
 printf ("Wyjscie z programu %u -- %s\n",
          mysql_errno (cnx_init),
         mysql_error (cnx_init));
exit (3);
}
mysql_free_result (in_result_set);
}
