#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "scatter_utils.h"

gboolean
on_frm_scatter_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_main_quit();
  return FALSE;
}


void
on_frm_scatter_show                    (GtkWidget       *widget,
                                        gpointer         user_data)
{
  g_print("rozpoczecie wykonywania on_frm_scatter_show.\n");
  load_data();
  draw_axis_and_scales();
  plot_graph();

}


void
on_cmd_redraw_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  load_data();
  draw_axis_and_scales();
  plot_graph();
}


gboolean
on_drawingarea1_event                  (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  g_print("rozpoczecie wykonywania on_drawingarea1_event.\n");
  draw_axis_and_scales();
  plot_graph();
  return FALSE;

}


gboolean
on_frm_scatter_event                   (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  g_print("on_frm_scatter_event\n");
  return FALSE;
}

