#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <mysql.h>


#include "callbacks.h"
#include "interface.h"
#include "support.h"
# include "sesi_utils.h"

GtkWidget *frm_main;
GtkWidget *frm_items_ordered;
GtkWidget *frm_find_item;
GtkWidget *frm_find_customer;

MYSQL *conx;
gboolean need_to_save_edits;



void
on_frm_main_set_focus                  (GtkWindow       *window,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{

}


gboolean
on_frm_main_button_press_event         (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}




on_frm_main_button_release_event       (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_frm_main_event                      (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_frm_main_hide                       (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


gboolean
on_frm_main_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_frm_main_key_release_event          (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_frm_main_realize                    (GtkWidget       *widget,
                                        gpointer         user_data)
{
connect_to_db();
}


gboolean
on_frm_main_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_main_quit();

  return FALSE;
}


void
on_frm_main_show                       (GtkWidget       *widget,
                                        gpointer         user_data)
{
gtk_combo_set_popdown_strings(GTK_COMBO(lookup_widget(frm_main, "cbo_customer_number")),get_customer_numbers());

}


void
on_combo_entry_customer_number_activate
                                        (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_combo_entry_customer_number_changed (GtkEditable     *editable,
                                        gpointer         user_data)
{
fill_customer_info();
}


void
on_combo_entry_customer_number_delete_text
                                        (GtkEditable     *editable,
                                        gint             start_pos,
                                        gint             end_pos,
                                        gpointer         user_data)
{

}


void
on_combo_entry_customer_number_insert_text
                                        (GtkEditable     *editable,
                                        gchar           *new_text,
                                        gint             new_text_length,
                                        gint            *position,
                                        gpointer         user_data)
{

}


void
on_entry_customer_name_changed         (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_customer_name_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_cmd_search_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_show_all(frm_find_customer);
}


void
on_cmd_save_edits_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
update_database();
need_to_save_edits = FALSE;
gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"),FALSE);

}


void
on_cmd_select_items_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_show_all(frm_items_ordered);
}


void
on_cmd_print_order_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
write_order();
}


void
on_cmd_exit_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(frm_main);
gtk_main_quit();
}


void
on_entry_last_changed                  (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_last_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_first_changed                 (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_first_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_title_changed                 (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_title_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_phone_changed                 (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_phone_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_ship_to_addr1_changed         (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_ship_to_addr1_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_bill_to_addr1_changed         (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_bill_to_addr1_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_ship_to_addr2_changed         (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_ship_to_addr2_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_bill_to_addr2_changed         (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_bill_to_addr2_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_ship_to_city_changed          (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_ship_to_city_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_ship_to_st_changed            (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_ship_to_st_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_ship_to_zip_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_ship_to_zip_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_bill_to_city_changed          (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_bill_to_city_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_bill_to_st_changed            (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_bill_to_st_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_entry_bill_to_zip_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_entry_bill_to_zip_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_txt_customer_comments_changed       (GtkEditable     *editable,
                                        gpointer         user_data)
{
g_print("on_txt_customer_comments_changed event...\n");
   gtk_widget_set_sensitive(lookup_widget(frm_main, "cmd_save_edits"), TRUE);
   need_to_save_edits = TRUE;
}


void
on_frm_items_ordered_set_focus         (GtkWindow       *window,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{

}


gboolean
on_frm_items_ordered_button_press_event
                                        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_frm_items_ordered_button_release_event
                                        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_frm_items_ordered_delete_event      (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_widget_hide(frm_items_ordered);
  return TRUE;
}


gboolean
on_frm_items_ordered_event             (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_frm_items_ordered_hide              (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


gboolean
on_frm_items_ordered_key_press_event   (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_frm_items_ordered_key_release_event (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_frm_items_ordered_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
fill_items_ordered();
}


void
on_frm_items_ordered_show              (GtkWidget       *widget,
                                        gpointer         user_data)
{
gtk_clist_set_column_justification(GTK_CLIST(
                                    lookup_widget(frm_items_ordered,
                                    "clist_items")),
                                     2, GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(GTK_CLIST(
                                     lookup_widget(frm_items_ordered,
                                     "clist_items_ordered")),
                                     2, GTK_JUSTIFY_RIGHT);
    gtk_clist_set_column_justification(GTK_CLIST(
                                     lookup_widget(frm_items_ordered,
                                     "clist_items_ordered")),
                                     3, GTK_JUSTIFY_RIGHT);
}


void
on_entry_item_number_activate          (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_entry_item_number_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_entry_item_number_insert_text       (GtkEditable     *editable,
                                        gchar           *new_text,
                                        gint             new_text_length,
                                        gint            *position,
                                        gpointer         user_data)
{

}


void
on_entry_item_number_delete_text       (GtkEditable     *editable,
                                        gint             start_pos,
                                        gint             end_pos,
                                        gpointer         user_data)
{

}


void
on_cmd_add_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
speed_add();
}


void
on_cmd_done_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_hide(frm_items_ordered);
}


void
on_clist_items_select_row              (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

}


void
on_clist_items_unselect_row            (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

}


gboolean
on_clist_items_button_press_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_clist_items_button_release_event    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_cmd_add_down_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
slow_add();
}


void
on_cmd_remove_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
remove_ordered_item();
}


void
on_clist_items_ordered_select_row      (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

}


void
on_clist_items_ordered_unselect_row    (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

}


gboolean
on_clist_items_ordered_button_press_event
                                        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_clist_items_ordered_button_release_event
                                        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_frm_find_item_delete_event          (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_widget_hide(frm_find_item);

  return FALSE;
}


void
on_cmd_find_item_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
enter_found_items((gchar*) gtk_editable_get_chars(GTK_EDITABLE(lookup_widget(frm_find_item, "entry_find_item")),0,-1));
}


void
on_cmd_find_items_done_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
gchar      *target_item;
   GtkCList   *clist_target;
   gint       row_target;

   g_print("on_cmd_find_item_done_clicked event...\n");



   clist_target = GTK_CLIST(lookup_widget(frm_find_item, "clist_found_items"));
   row_target = (gint) g_list_nth_data ( (clist_target)->selection, 0);
   gtk_clist_get_text(clist_target,
                      row_target, 0, &target_item);

   select_item(target_item);



   gtk_widget_hide (frm_find_item);
}


gboolean
on_frm_find_customer_delete_event      (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_widget_hide(frm_find_customer);
  return TRUE;
}


void
on_cmd_find_customer_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
enter_found_customers((gchar*) gtk_editable_get_chars(GTK_EDITABLE(lookup_widget(frm_find_customer, "entry_find_customer")),0,-1));

}


void
on_cmd_find_customer_done_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
gchar      *target_item;
   GtkCList   *clist_target;
   gint       row_target;

   g_print("on_cmd_find_item_done_clicked event...\n");



   clist_target = GTK_CLIST(lookup_widget(frm_find_item, "clist_found_items"));
   row_target = (gint) g_list_nth_data ( (clist_target)->selection, 0);
   gtk_clist_get_text(clist_target,
                      row_target, 0, &target_item);

   select_item(target_item);



   gtk_widget_hide (frm_find_item);
}


void
on_cmd_search_for_item_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_show_all(frm_find_item);
}

