#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "ddc1.h"

GtkWidget *window1;

void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *scrolledwindow1;
   gchar     *row[17] = {"", "", "", "", "", 
                         "", "", "", "", "",
                         "", "", "", "", "",
                         "", ""};

   g_print("Starting on_button_1_clicked...\n");

   gtk_widget_destroy(lookup_widget(window1, "scrolledwindow1"));
   gtk_widget_unref(GTK_WIDGET(lookup_widget(window1, "scrolledwindow1")));

   scrolledwindow1 = create_ddc("tbl_customers", row);
   gtk_widget_ref(scrolledwindow1);

   gtk_box_pack_start(GTK_BOX(lookup_widget(window1, "vbox1")), 
                     scrolledwindow1, TRUE, TRUE, 0);

   gtk_widget_show_all(window1);

   g_print("Exiting on_button_1_clicked...\n");
}


void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *scrolledwindow1;
   gchar     *row[3] = {"", "", ""};

   g_print("Starting on_button_1_clicked...\n");

   gtk_widget_destroy(lookup_widget(window1, "scrolledwindow1"));
   gtk_widget_unref(GTK_WIDGET(lookup_widget(window1, "scrolledwindow1")));

   scrolledwindow1 = create_ddc("tbl_items", row);
   gtk_widget_ref(scrolledwindow1);

   gtk_box_pack_start(GTK_BOX(lookup_widget(window1, "vbox1")), 
                     scrolledwindow1, TRUE, TRUE, 0);

   gtk_widget_show_all(window1);

   g_print("Exiting on_button_1_clicked...\n");

}

