use commish;

/* Listing 8.1
 *
 * Ten plik laduje dane z tbl_place.txt
 * do tabeli tbl_place w bazie commish.
 *
 * uzycie:
 *
 * % mysql -t < listing.8.1
 */

drop table if exists tbl_place;

create table tbl_place
(
        nr_wiersza      INT   PRIMARY KEY    AUTO_INCREMENT,
	nr_klienta	  varchar(50),
	nazwa_klienta     varchar(50),
	sprzedawca        varchar(50),
        kraj              varchar(50),
        miasto            varchar(50),
        stan              char(2),
        kod               varchar(50),
        data_dost         varchar(50),
        nr_towaru         varchar(50),
        liczba_sztuk      smallint,
        cena_jedn         decimal(10,2),
        wart_netto        decimal(10,2),
        nr_faktury        varchar(50),
        data_faktury      varchar(50),
        liczba_faktur     smallint,
        wartosc_faktury   decimal(10,2)
);

LOAD DATA INFILE "/home/ch08/tbl_place.txt"
     INTO TABLE tbl_place
     FIELDS TERMINATED BY ','
     IGNORE 1 LINES
       (nr_klienta,
	nazwa_klienta,
	sprzedawca,
        kraj,
        miasto,
        stan,
        kod,
        data_dost,
        nr_towaru,
        liczba_sztuk,
        cena_jedn,
        wart_netto,
        nr_faktury,
        data_faktury,
        liczba_faktur,
        wartosc_faktury);

select count(*) from tbl_place;
